hdu 1068(最大独立集)

Girls and Boys

Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 10500    Accepted Submission(s): 4849


Problem Description
the second year of the university somebody started a study on the romantic relations between the students. The relation “romantically involved” is defined between one girl and one boy. For the study reasons it is necessary to find out the maximum set satisfying the condition: there are no two students in the set who have been “romantically involved”. The result of the program is the number of students in such a set.

The input contains several data sets in text format. Each data set represents one set of subjects of the study, with the following description:

the number of students
the description of each student, in the following format
student_identifier:(number_of_romantic_relations) student_identifier1 student_identifier2 student_identifier3 ...
or
student_identifier:(0)

The student_identifier is an integer number between 0 and n-1, for n subjects.
For each given data set, the program should write to standard output a line containing the result.
 
Sample Input
7 0: (3) 4 5 6 1: (2) 4 6 2: (0) 3: (0) 4: (2) 0 1 5: (1) 0 6: (2) 0 1 3 0: (2) 1 2 1: (1) 0 2: (1) 0
 
Sample Output
5 2
 
题意:找到所有无缘分的人有多少?
题解:最大点独立集 = 顶点数 - 最大匹配数,但是0-4,4-0连了两次,所以最大匹配要除二.
我对这种两边都是同一集合元素然后做二分图匹配的题目的看法就是:要连双向边,然后最大匹配数要除以二。
但是这题不要连双向边,因为它给的条件是对称的。
#include<iostream>
#include<cstdio>
#include<cstring>
#include <algorithm>
#include <math.h>
using namespace std;
const int N = 1005;
int graph[N][N];
bool vis[N];
int linker[N],n;
bool dfs(int u){
    for(int i=0;i<n;i++){
        if(graph[u][i]&&!vis[i]){
            vis[i] = true;
            if(linker[i]==-1||dfs(linker[i])){
                linker[i] = u;
                return true;
            }
        }
    }
    return false;
}
int main()
{
    while(scanf("%d",&n)!=EOF){
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++)
                graph[i][j] = 0;
        }
        for(int i=0;i<n;i++){
            int u,v,num;
            scanf("%d: (%d)",&u,&num);
            for(int j=0;j<num;j++){
                scanf("%d",&v);
                graph[u][v] = 1;
            }
        }
        int ans = 0;
        memset(linker,-1,sizeof(linker));
        for(int i=0;i<n;i++){
            memset(vis,false,sizeof(vis));
            if(dfs(i)) ans++;
        }
        printf("%d
",n-ans/2);
    }
    return 0;
}
原文地址:https://www.cnblogs.com/liyinggang/p/5712023.html